local SUI_A_Time = 0
local SUI_A_Interval = 0.2
local elapsed = 0
local SUI_A_Health = "interface\\addons\\SpartanUI_Animated\\Animations\\Health\\HealthBar"
local SUI_A_Cast = "interface\\addons\\SpartanUI_Animated\\Animations\\Cast\\CastBar"
local t_power = { };
local lUnitExists = UnitExists
local lUnitPowerType = UnitPowerType
local s_table = { ["player"] = SUI_PlayerFrame, 
				  ["target"] = SUI_targetFrame,
				  ["pet"]	 = SUI_petFrame,
}

do
	t_power[0] = "interface\\addons\\SpartanUI_Animated\\Animations\\Mana\\Manabar" --"mana",
	t_power[1] = "interface\\addons\\SpartanUI_Animated\\Animations\\Rage\\RageBar" --"rage",
	t_power[2] = "interface\\addons\\SpartanUI_Animated\\Animations\\Energy\\EnergyBar" --"focus", 
	t_power[3] = t_power[2] --"energy", 
	t_power[4] = t_power[2] --"happiness", 
	t_power[5] = t_power[0] --"runes", 
	t_power[6] = t_power[0] --"runic power" 
end

local Sui_anime = function(self,power)	
	local frameCount = (self.frameCount or 0) % 40 + 1
	self.frameCount = frameCount
	self:SetStatusBarTexture(power..tostring(frameCount))	
	return
end

local SUI_A_OnUpdate = function(self,elapsed)
	SUI_A_Time = SUI_A_Time + elapsed;	
	while ( SUI_A_Time > SUI_A_Interval ) do
		for unit,frame in pairs(s_table) do
			if lUnitExists(unit) then
				local power = (lUnitPowerType(unit) or 0) % 7
				Sui_anime(frame.Health, SUI_A_Health);
				Sui_anime(frame.Power,t_power[power]);
				if frame.Castbar.casting or frame.Castbar.channeling then
					Sui_anime(frame.Castbar, SUI_A_Cast);
				end
			end
		end	
		SUI_A_Time = SUI_A_Time - SUI_A_Interval;
	end
	return
end

do	
	local f=CreateFrame("Frame",nil,UIParent)
	f:SetFrameStrata("BACKGROUND")
	SUI_PlayerFrame.Castbar:SetStatusBarColor(1,1,1,1);	
	f:HookScript("OnUpdate", SUI_A_OnUpdate);
end